#include <iostream>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin>>n;
    int a[n];
    for(int i=0;i<n;i++)
        cin>>a[i];
    int pref[n],ind[n];
    ind[0]=0;
    if(n>2)
    {
        if((a[1]<a[0])&&(a[0]<=a[2]))
            ind[1]=1;
        else
            ind[1]=0;
    }
    pref[0]=0;
    if(n>1)
    {
        if(a[1]<a[0])
            pref[1]=1;
        else
            pref[1]=0;
    }
    for(int i=2;i<n;i++)
    {
        if(a[i]<a[i-1])
        {
            pref[i]=pref[i-1]+1;
            if(i<n-1)
            {
                if(a[i-1]<=a[i+1])
                    ind[i]=ind[i-1]+1;
                else
                    ind[i]=ind[i-1];
            }
            if(i==n-1)
                ind[i]=ind[i-1]+1;
        }
        else
        {
            ind[i]=ind[i-1];
            pref[i]=pref[i-1];
        }
    }
    int los[n];
    los[0]=0;
    if(n>1)
        los[1]=0;
    for(int i=2;i<n;i++)
    {
        if((a[i]<a[i-1])&&(a[i]<a[i-2]))
            los[i]=los[i-1]+1;
        else
            los[i]=los[i-1];
    }
    int q,l,r,br,brl;
    cin>>q;
    for(int i=0;i<q;i++)
    {
        cin>>l>>r;
        l--;
        r--;
        if(r-l<2)
            cout<<"DA"<<endl;
        else
        {
            br=pref[r]-pref[l];
            brl=los[r]-los[l+1];
            if((br<2)&&(brl==0))
                cout<<"DA"<<endl;
            else
            {
                if((br==1)&&(a[r-1]>a[r]))
                    cout<<"DA"<<endl;
                else
                {
                    if(br==1)
                    {
                        if(ind[r]-ind[l]==1)
                            cout<<"DA"<<endl;
                        else
                            cout<<"NE"<<endl;
                    }
                    else
                        cout<<"NE"<<endl;
                }
            }
        }
    }
}